﻿/**
* jQuery pbiui 1.0.0
* 
* Author xyf [ xyf_victor@163.com ] 
* 
*/
	/*-type--2016/02/18-----*/
var pidsType = 
	[
      0x00,"unused",
      0x01,"Mpeg1 Video",
      0x02,"Mpeg2 Video",
      0x03,"Mpeg1 Audio",
      0x04,"Mpeg2 Audio",
      0x05,"Private Data",   
      0x06,"Private Data", 
      0x07,"MHEG Data", 
      0x08,"DSM CC", 
      0x09,"Auxiliary  Data", 
      0x0a,"DSM CC",
      0x0b,"DSM CC",
      0x0c,"DSM CC",
      0x0d,"DSM CC",
      0x0e,"Auxiliary Data",
      0x0f,"Mpeg22 AAC",  
      0x10,"Mpeg4 Video",
      0x11,"Mpeg4 AAC",
      0x12,"MPEG-4 FlexMux",
      0x13,"MPEG-4 FlexMux",
      0x14,"DSM CC",
      0x15,"Meta Data",   
      0x16,"Meta Data", 
      0x17,"DSM CC Meta", 
      0x18,"DSM CC Meta", 
      0x19,"Download Meta", 
      0x1a,"IPMP",
      0x1b,"H.264 Video",
      0x1c,"Reserved",
      0x1d,"Reserved",
      0x1e,"Reserved",
      0x1f,"Reserved", 
      0x20,"Reserved",
      0x21,"Reserved",
      0x22,"Reserved",
      0x23,"Reserved",
      0x24,"H.265 Video",
      0x25,"Reserved",   
      0x26,"Reserved", 
      0x27,"Reserved", 
      0x28,"Reserved", 
      0x29,"Reserved", 
      0x2a,"Reserved",
      0x2b,"Reserved",
      0x2c,"Reserved",
      0x2d,"Reserved",
      0x2e,"Reserved",
      0x2f,"Reserved", 
      0x30,"Reserved",
      0x31,"Reserved",
      0x32,"Reserved",
      0x33,"Reserved",
      0x34,"Reserved",
      0x35,"Reserved",
      0x36,"Reserved", 
      0x37,"Reserved", 
      0x38,"Reserved", 
      0x39,"Reserved", 
      0x3a,"Reserved",
      0x3b,"Reserved",
      0x3c,"Reserved",
      0x3d,"Reserved",
      0x3e,"Reserved",
      0x3f,"Reserved", 
      0x40,"Reserved",
      0x41,"Reserved",
      0x42,"AVS+",
      0x43,"AVS+",
      0x44,"Reserved",
      0x45,"Reserved",   
      0x46,"Reserved", 
      0x47,"Reserved", 
      0x48,"Reserved", 
      0x49,"Reserved", 
      0x4a,"Reserved",
      0x4b,"Reserved",
      0x4c,"Reserved",
      0x4d,"Reserved",
      0x4e,"Reserved",
      0x4f,"Reserved",    
      0x50,"Reserved",
      0x51,"Reserved",
      0x52,"Reserved",
      0x53,"Reserved",
      0x54,"Reserved",
      0x55,"Reserved",
      0x56,"Reserved",
      0x57,"Reserved",
      0x58,"Reserved",
      0x59,"Reserved",
      0x5a,"Reserved",
      0x5b,"Reserved",
      0x5c,"Reserved",
      0x5d,"Reserved",
      0x5e,"Reserved",
      0x5f,"Reserved",
      0x60,"Reserved",
      0x61,"Reserved",
      0x62,"Reserved",
      0x63,"Reserved",
      0x64,"Reserved",
      0x65,"Reserved",
      0x66,"Reserved",
      0x67,"Reserved",
      0x68,"Reserved",
      0x69,"Reserved",
      0x6a,"Reserved",
      0x6b,"Reserved",
      0x6c,"Reserved",
      0x6d,"Reserved",
      0x6e,"Reserved",
      0x6f,"Reserved",
      0x70,"Reserved",
      0x71,"Reserved",
      0x72,"Reserved",
      0x73,"Reserved",
      0x74,"Reserved",
      0x75,"Reserved",
      0x76,"Reserved",
      0x77,"Reserved",
      0x78,"Reserved",
      0x79,"Reserved",
      0x7a,"Reserved",
      0x7b,"Reserved",
      0x7c,"Reserved",
      0x7d,"Reserved",
      0x7e,"Reserved",
      0x7f,"Reserved",
      0x80,"DigiCipher II",
      0x81,"Dolby Audio",
      0x82,"DTS 6CH Audio",
      0x83,"Dolby TrueHD",
      0x84,"Dolby D+",
      0x85,"DTS 8CH Audio",
      0x86,"DTS 8CH Audio", 
      0x87,"Dolby D+", 
      0x88,"Private Data", 
      0x89,"Private Data", 
      0x8a,"Private Data",
      0x8b,"Private Data",
      0x8c,"Private Data",
      0x8d,"Private Data",
      0x8e,"Private Data",
      0x8f,"Private Data", 
      0x90,"subtitle",
      0x91,"Private Data",
      0x92,"Private Data",
      0x93,"Private Data",
      0x94,"Private Data",
      0x95,"ATSC DSM CC",
      0x96,"Private Data",
      0x97,"Private Data",
      0x98,"Private Data",
      0x99,"Private Data",
      0x9a,"Private Data",
      0x9b,"Private Data",
      0x9c,"Private Data",
      0x9d,"Private Data",
      0x9e,"Private Data",
      0x9f,"Private Data",
      0xa0,"Private Data",
      0xa1,"Private Data",
      0xa2,"Private Data",
      0xa3,"Private Data",
      0xa4,"Private Data",
      0xa5,"Private Data",
      0xa6,"Private Data",
      0xa7,"Private Data",
      0xa8,"Private Data",
      0xa9,"Private Data",
      0xaa,"Private Data",
      0xab,"Private Data",
      0xac,"Private Data",
      0xad,"Private Data",
      0xae,"Private Data",
      0xaf,"Private Data",
      0xb0,"Private Data",
      0xb1,"Private Data",
      0xb2,"Private Data",
      0xb3,"Private Data",
      0xb4,"Private Data",
      0xb5,"Private Data",
      0xb6,"Private Data",
      0xb7,"Private Data",
      0xb8,"Private Data",
      0xb9,"Private Data",
      0xba,"Private Data",
      0xbb,"Private Data",
      0xbc,"Private Data",
      0xbd,"Private Data",
      0xbe,"Private Data",
      0xbf,"Private Data",
      0xc0,"DigiCipher II",
      0xc1,"Dolby D SC",
      0xc2,"ATSC DSM CC",
      0xc3,"Private Data",
      0xc4,"Private Data",
      0xc5,"Private Data",
      0xc6,"Private Data",
      0xc7,"Private Data",
      0xc8,"Private Data",
      0xc9,"Private Data",
      0xca,"Private Data",
      0xcb,"Private Data",
      0xcc,"Private Data",
      0xcd,"Private Data",
      0xce,"Private Data",
      0xcf,"AAC SC",
      0xd0,"Private Data",
      0xd1,"Ultra HD video",
      0xd2,"Private Data",
      0xd3,"Private Data",
      0xd4,"Private Data",
      0xd5,"Private Data",
      0xd6,"Private Data",
      0xd7,"Private Data",
      0xd8,"Private Data",
      0xd9,"Private Data",
      0xda,"Private Data",
      0xdb,"H.264 SC",
      0xdc,"Private Data",
      0xdd,"Private Data",
      0xde,"Private Data",
      0xdf,"Private Data",
      0xe0,"Private Data",
      0xe1,"Private Data",
      0xe2,"Private Data",
      0xe3,"Private Data",
      0xe4,"Private Data",
      0xe5,"Private Data",
      0xe6,"Private Data",
      0xe7,"Private Data",
      0xe8,"Private Data",
      0xe9,"Private Data",
      0xea,"WMV",
      0xeb,"Private Data",
      0xec,"Private Data",
      0xed,"Private Data",
      0xee,"Private Data",
      0xef,"Private Data",
      0xf0,"Private Data",
      0xf1,"Private Data",
      0xf2,"Private Data",
      0xf3,"Private Data",
      0xf4,"Private Data",
      0xf5,"Private Data",
      0xf6,"Private Data",
      0xf7,"Private Data",
      0xf8,"Private Data",
      0xf9,"Private Data",
      0xfa,"PCR",        
      0xfb,"PMT",
      0xfc,"Ghost Data",
      0xfd,"EMM Data",
      0xfe,"ECM Data",
      0xff,"Private Data"      
	];
	/*-End--2016/02/18-----*/


var FUNC_TYPE = {
	POWER : 0x01,
	APPLACATION : 0x02,
	UPGRADE :0x03,
	TEMPERATURE : 0x04,
	PARAMETER: 0x05,
	FPGA: 0x06,
	LCD: 0x07,
	FAN: 0x08,
	TRANSCEIVER: 0x09,
	CARD_SLOT: 0x0a,
	SPI: 0x0b,
	TS_IN: 0x10,
	ASI_IN: 0x12,
	ASI_OUT: 0x13,
	TS_IP_IN: 0x14,
	TS_IP_OUT: 0x15,
	S2_TUNER: 0x16,
	T2_TUNER: 0x17,
	CI_CAM: 0x18,
	REMUX: 0x1a,
	ENCODER: 0x1b,
	TSOIP: 0x19,
	BISS: 0x1c,
	QAM_MODULATOR: 0x1d,
	COFDM_MODULATOR: 0x1e
};

var FUNC_S_TYPE =
[
	// "digital television service",
	// "digital radio sound service",
	// "Teletext service",
	// "NVOD reference service",
	// "NVOD time-shifted service",
	// "mosaic service",
	// "advanced codec digital radio sound service",
	// "advanced codec mosaic service",
	// "data bradcast service",
	// "reserved for Common Interface Usage",
	// "RCS Map",
	// "RCS FLS",
	// "DVB MHP service",
	// "MPEG-2 HD digital television service",
	// "advanced codec SD digital television service",
	// "advanced codec SD NVOD time-shifted service",
	// "advanced codec SD NVOD reference service",
	// "advanced codec HD digital television service",
	// "advanced codec HD NVOD time-shifted service",
	// "digital television service",
	// "advanced codec HD NVOD time-shifted service",
	// "advanced codec HD NVOD reference service"
		"digital television service",
		"digital radio sound service",
		"Teletext service",
		"NVOD reference service",
		"NVOD time-shifted service",
		"mosaic service",
		"PAL coded signal ",
		"SECAM coded signal",
		"D/D2-MAC",
		"advances codec digital radio sound service",
		"advances codec mosaic service",
		"data broadcast service",
		"reserved for common interface usage",
		"RCS MAP",
		"RCS FLS",
		"DVB MHP service",
		"MPEG-2 HD digital television service"
];

var route_id = -1;

(function ($){
	
	/***********************************
	功能：检查浏览器的版本  
	data:  lxzheng_2016/06/24     
    ***********************************/ 
	$.judge_browser_version = function()	
	{
		var _uat=navigator.userAgent;

		if(_uat.indexOf("MSIE 6.0")>0) alert("ie6");
		else if(_uat.indexOf("MSIE 7.0")>0) alert("ie7");
		else if(_uat.indexOf("MSIE 8.0")>0) alert("ie8");
		else if(_uat.indexOf("Firefox")>0) alert("firefox"); 
	}

	/***********************************
	 功能：检查表格是否规整  
	 参数：tb－－需要检查的表格ID  
	data:  lxzheng_2016/04/12     
    ***********************************/  
    $.checkTable = function(tb)
	{  
	    if(tb.rows.length==0) return false;  
	    if(tb.rows[0].cells.length==0) return false;  	
		/*
		for(var i=0;i<tb.rows.length;i++)
		{  	
			if(tb.rows[0].cells.length!=tb.rows[i].cells.length) return false;  	
		}  
		*/
		return true;  
	};  
	/*************************************************************************
	功能：合并表格  
	参数：tb－需要合并的表格ID  (可以是table、tbody )
	参数：colLength－－需要对前几列的行进行合并，比如 .想合并前两列，后面的数据列忽略合并，colLength应为2 
	参数：rowLength－－需要对前几行的列进行合并，比如 .想合并前行列，后面的数据行忽略合并，rowLength应为2 
	缺省表示对全部列合并     
	data:  lxzheng_2016/04/12     
	*************************************************************************/  
	$.uniteTable = function(tb,colLength,rowLength)
	{  
		//检查表格是否规整  
	
		if(!$.checkTable(tb)) return; 
	
		var i=0;  
	
		var j=0;  
	
		var rowCount=tb.rows.length; //行数  
	
		var colCount=tb.rows[0].cells.length; //列数  
	
		var obj1=null;  
	
		var obj2=null;  
	
		//为每个单元格命名  
		for(i=0;i<rowCount;i++)
		{  
			for(j=0;j<colCount;j++)
			{        
				if(typeof(tb.rows[i].cells[j]) == "undefined")
				{	
					continue;
				}
				tb.rows[i].cells[j].id="tb_" + i.toString() + "_" + j.toString();  
			}  
		}  
	
		//逐列检查合并  
		for(i=0;i<colCount;i++)
		{  
			if(i==colLength) break;  
			obj1=document.getElementById("tb_0_"+i.toString()) ;
			if(obj1 != null && typeof(obj1) != "undefined")
			{
				for(j=1;j<rowCount;j++)
				{  
					obj2=document.getElementById("tb_"+j.toString()+"_"+i.toString());
					  
					if((obj2 != null) && (typeof(obj2) != "undefined") && (obj2.firstChild.nodeName == "#text")) // only input == text ,才合并， 其他 比如 ，ＳＥＬＥＣＴ　是　不合并的，如果需要　用　这个　函数　，注意。
					{
						if(obj1.innerText==obj2.innerText)
						{ 
						    obj1.rowSpan++;  
						    obj2.parentNode.removeChild(obj2);  
	
						}else
						{  
						    obj1=document.getElementById("tb_"+j.toString()+"_"+i.toString());  
						}  
					}
				}  
			}
		}  
	
		//逐行检查合并  
		for(i=0;i<rowCount;i++)
		{ 
			if(i==rowLength) break; 
			obj1=document.getElementById("tb_"+i.toString()+"_0") ;
			if(obj1 != null && typeof(obj1) != "undefined")
			{	
				for(j=1;j<colCount;j++)
				{  
					obj2=document.getElementById("tb_"+i.toString()+"_"+j.toString());  
					if((obj2 != null) && (typeof(obj2) != "undefined") && (obj2.firstChild.nodeName == "#text")) 
					{
						if(obj1.innerText==obj2.innerText)
						{  
						
							obj1.colSpan++;  
							obj2.parentNode.removeChild(obj2);			
						}else
						{  
						    obj1=document.getElementById("tb_"+i.toString()+"_"+j.toString());  
						}  
					}
				}	
				//obj1.colSpan 至少 一行中 有 3个 以上相同的 才 添加 col_td 的 class
				if(obj1.colSpan > 3 && obj1.colSpan <= colCount)
				{
					$("#tb_"+i.toString()+"_0").attr("class","col_td");  
				}	 			
			}	 
		}
	};  

	/* lxzheng 2016/03/23 for 进制 获取  */
	$.getConvertNum = function(ary_sw)
	{
		var ConvertNum = 0;
		switch(ary_sw)
		{
			case 0:
				ConvertNum = 10; //十进制
				break;
			case 1:
				ConvertNum = 16; //十进制
				break;
			default:
				ConvertNum = 10; //十进制
				break;
				
		}
		return ConvertNum;
	};
	
	/* lxzheng 2016/03/23 for 十进制  转换 为 任意 进制  system*/
	$.decimalConvert = function(strDecimal,system)
	{
		var strdest = strDecimal.toString(system);
		return strdest;
	};
	
	/* lxzheng 2016/03/23 for 其他进制 转换 为 十进制 */
	$.convertDecimal = function(strOtherBase,system)
	{	
		var strDecimal = parseInt(strOtherBase,system);
		return strDecimal;
	};
		
	/* lxzheng 2016/03/21 for Basic Infos common*/
	$.getBasicInfos=function(dest,src)
	{
		jQuery.extend(dest, src);
		//return dest;
	};
	
	/* End for Basic Infos common*/
	
	/**** lxzheng 2016/02/24  update  level0 勾选状态 即（level 0  根节点）*****/
	$.updateLevel0Node=function(targetNode)
	{
		var Level0_ParentNode = targetNode.getParentNode();
		if(typeof(Level0_ParentNode.checked) != "undefined")
		{							
			for(var j=0,m=0;j<Level0_ParentNode.children.length;j++)
			{
				if(Level0_ParentNode.children[j].checked == true)
				{
					m++;
				}
			}
			if(m==0)
			{
				Level0_ParentNode.checked = false;				
				Level0_ParentNode.halfCheck = false;					
			}
			else if( (m > 0) && (m < Level0_ParentNode.children.length)) //halfCheck
			{
				Level0_ParentNode.checked = true;				
				Level0_ParentNode.halfCheck = true;				
			}else if(m == Level0_ParentNode.children.length)
			{
				Level0_ParentNode.checked = true;				
				Level0_ParentNode.halfCheck = false;				
			}
				
			
			if(Level0_ParentNode.checked == false )
			{										
				Level0_ParentNode.checked = true;				
				Level0_ParentNode.halfCheck = false;		
			}
			
			return Level0_ParentNode;	
		}
	};

	/*
	 *数据传输
	 */
		//生成树的节目节点
	$.pbi_GenProTreeNode=function(Node,para,muxflag,system,boardNum){
		var G=GlobalSpace,
			P = {
				Have_flag:-1,
				prog_key:-1,
				CH_index:-1,
				N_index:-1,
				P_index:-1,
				mux_dest_func_channel : -1,
				Src_name:'',
				temp_obj:{},
				temp_es_pids:[],
				temp_ecm_pids:[],
				S_TYPE:0,
				P_name:'',
				P_name_new:'',
				P_FCA_MODE:0,
				pn:0,      //old_pro_num
				pn_new:0,
				pmt_pid:0,
				pcr_pid:0,
                pcr_pass:-1,
                lcnVal:-1,
                caSysID:[]
			},
			temp_obj={},
			temp_es_pids=[],
			temp_ecm_pids=[],
			temp_obj_p={},
			temp_obj_i={},
			info_id = 1,
			i=0;

		jQuery.extend(P, para);

        temp_obj = P.temp_obj;
		temp_es_pids = P.temp_es_pids;
        temp_ecm_pids = P.temp_ecm_pids;

		if(P.CH_index==-1||P.N_index==-1 || P.P_index==-1)
			return P.N_index;
		
		if(!P.P_name_new)
		{
			P.P_name_new = P.pn;
		}
		
		Node[P.N_index]={};
				
		temp_obj_p=Node[P.N_index];
        temp_obj_p.caSysID = P.caSysID;
		temp_obj_p.pId= temp_obj.id; 
		
		temp_obj_p.id = "p";
		temp_obj_p.id += P.P_index;
		temp_obj_p.id += temp_obj.id;
			
		temp_obj_p.name=P.P_name_new;
		
		temp_obj_p.nocheck = true;	
		if(P.P_FCA_MODE){
			temp_obj_p.name += ' <b style="color:red">[$]</b>';
		}
		if(P.Have_flag == 1)
			temp_obj_p.iconSkin="pPro";
		else
			temp_obj_p.iconSkin="pProNo";	

/*		switch(P.S_TYPE){
			case $.DEF.S_TYPE.TV:				
				if(P.Have_flag == 1)
					temp_obj_p.iconSkin=pPro; 
				else
					temp_obj_p.iconSkin=pProNo;					
				break;
				
			case $.DEF.S_TYPE.BROADCAST:			
				if(P.Have_flag == 1)
					temp_obj_p.iconSkin="bCast";
				else
					temp_obj_p.iconSkin="bCasNo";								
				break;
				
			case $.DEF.S_TYPE.DATA:	
				if(P.Have_flag == 1)
					temp_obj_p.iconSkin="pData";
				else
					temp_obj_p.iconSkin="pDataNo";								
				break;
				
			default :
				temp_obj_p.iconSkin="unknown";
				break;				
		}*/

		//temp_obj_p.iconSkin="pPro";
		temp_obj_p.mux_ena=0;
		temp_obj_p.t ="Source:"+P.temp_obj.t+"-"+P.pn; 
		temp_obj_p.pn =P.pn; 
			
		temp_obj_p.index = P.CH_index;

		if(parseInt(muxflag) == 1 && parseInt(boardNum) == 7) //level-2 for out mux 
		{
			///temp_obj_p.dest_func_channel = P.dest_func_channel;
			temp_obj_p.dest_func_channel  = mux_dest_func_channel;
			temp_obj_p.prog_key = P.prog_key;
			if(parseInt(G.max_prog_key) < parseInt(P.prog_key))
			{
				G.max_prog_key = parseInt(P.prog_key);
			}

		}
		P.N_index++;

		if(P.pn_new){
            Node[P.N_index]={};
            temp_obj_i=Node[P.N_index];
            temp_obj_i.pId= temp_obj_p.id;

            temp_obj_i.id = "i";
            temp_obj_i.id += info_id;
            temp_obj_i.id += temp_obj_p.id;
            //console.log(temp_obj_i.id);

            temp_obj_i.name='Service ID:' + $.decimalConvert(P.pn_new,system);
            temp_obj_i.t='Service ID';
            P.N_index++;
            info_id++;
		}else
		{
			console.log("P.pn_new == NULL");
		}
        if(muxflag == 1 && P.lcnVal != -1) {
            Node[P.N_index]={};
            temp_obj_i=Node[P.N_index];
            temp_obj_i.pId= temp_obj_p.id;

            temp_obj_i.id = "i";
            temp_obj_i.id += info_id;
            temp_obj_i.id += temp_obj_p.id;

            temp_obj_i.name='LCN:'+P.lcnVal;
            temp_obj_i.t = "LCN";
            temp_obj_i.iconSkin="adddata";
            P.N_index++;
            info_id++;
        }


		if(P.pmt_pid){
		Node[P.N_index]={};
		temp_obj_i=Node[P.N_index];
		temp_obj_i.pId= temp_obj_p.id; 
			
		temp_obj_i.id = 'i';
		temp_obj_i.id += info_id;
		temp_obj_i.id += temp_obj_p.id;
//console.log(temp_obj_i.id);
			
		temp_obj_i.name='PMT PID:'+ $.decimalConvert(P.pmt_pid,system);
		temp_obj_i.t='PMT PID';
		temp_obj_i.iconSkin="tab";
            info_id++;
		P.N_index++;
		}else
		{
			console.log("P.pmt_pid == NULL");
		}

		//info_id = 3;
		if(P.pcr_pid){
			Node[P.N_index]={};
			temp_obj_i=Node[P.N_index];
			temp_obj_i.pId= temp_obj_p.id; 
			
			temp_obj_i.id = 'i';
			temp_obj_i.id += info_id;
			temp_obj_i.id += temp_obj_p.id;
//console.log(temp_obj_i.id);
			
			temp_obj_i.name='PCR PID:'+ $.decimalConvert(P.pcr_pid,system);
			temp_obj_i.t='PCR PID';
            if(P.pcr_pass != -1){
                temp_obj_i.pass = P.pcr_pass;
            }
			temp_obj_i.iconSkin="pcr";
			P.N_index++;	
			info_id++;
        //    console.log(temp_obj_i);
		}else
		{
			console.log("P.pcr_pid == NULL");
		}

    	if(temp_es_pids){
			for(i=0; i<temp_es_pids.length; i++){
				Node[P.N_index]={};
				temp_obj_i=Node[P.N_index];
				temp_obj_i.pId= temp_obj_p.id; 
				
				temp_obj_i.id = 'i';
				
				//temp_obj_i.id += (info_id+i);
				temp_obj_i.id += info_id;
				temp_obj_i.id += temp_obj_p.id;
				
				var location = parseInt(temp_es_pids[i].type)*2 ; //0x02 的 位置
				
				if(parseInt(temp_es_pids[i].type) != 0 && parseInt(temp_es_pids[i].type) == parseInt(pidsType[location]) && pidsType[location + 1] != "Reserved")
				{
				//	console.log(pidsType[location]);
				//	console.log(pidsType[location + 1]); //相对应的 PID Type
					temp_obj_i.t = pidsType[location + 1];				
					 
					if(pidsType[location + 1].indexOf("Video") > 0 )
					{
					    temp_obj_i.iconSkin="video";
					}
					else if((pidsType[location + 1].indexOf("Audio") > 0 ) || (pidsType[location + 1].indexOf("AAC") > 0 ))
					{
						temp_obj_i.iconSkin="audio";
					}
					else if(pidsType[location + 1].indexOf("Private Data") > 0 ) //私人的，专用的 
					{
						temp_obj_i.iconSkin="privatedata";
					}
					else if(pidsType[location + 1].indexOf("Data") > 0 )  
					{
						temp_obj_i.iconSkin="otherdata";
					}					
					else if(pidsType[location + 1].indexOf("Download") > 0 )  
					{
						temp_obj_i.iconSkin="download";
					}					
					else if((pidsType[location + 1].indexOf("WMV") > 0) || (pidsType[location + 1].indexOf("AVS") > 0))  
					{
						temp_obj_i.iconSkin="wmv";
					}else
					{
						temp_obj_i.iconSkin="info";				
					}										
				}
				else
				{
					temp_obj_i.t="Unknow";
					temp_obj_i.iconSkin="unknown";	
				}
				if(parseInt(boardNum) == 7)
				{
					temp_obj_i.name=temp_obj_i.t +':'+ $.decimalConvert(temp_es_pids[i].mux_pid,system);
				}else
				{
					temp_obj_i.name=temp_obj_i.t +':'+ $.decimalConvert(temp_es_pids[i].pid,system);
				}
                if(typeof temp_es_pids[i].pass != undefined){
                    temp_obj_i.pass = temp_es_pids[i].pass;
                }
				P.N_index++;
				info_id++;
			}
		}else
		{
			console.log("temp_es_pids == NULL");
		}
        if(temp_ecm_pids) {
            for (i = 0; i < temp_ecm_pids.length; i++) {
             //   console.log(temp_ecm_pids[i]);

                Node[P.N_index] = {};
                temp_obj_i = Node[P.N_index];
                temp_obj_i.pId = temp_obj_p.id;

                temp_obj_i.id = 'i';
                temp_obj_i.id += info_id;
                temp_obj_i.id += temp_obj_p.id;
                temp_obj_i.iconSkin = "info";
                temp_obj_i.t = "ECM";
                if(typeof temp_ecm_pids[i].pass != undefined){
                    temp_obj_i.pass = temp_ecm_pids[i].pass;
                }
                temp_obj_i.name = (muxflag == 1)?temp_obj_i.t + ':' + $.decimalConvert(temp_ecm_pids[i].mux_pid, system):temp_obj_i.t + ':' + $.decimalConvert(temp_ecm_pids[i], system);
                P.N_index++;
                info_id++;
            }
        }
        /*-lxzheng 2016/02/22 ---For mux ---*/
		if(muxflag == 1)
		{
			if(P.pn){
				Node[P.N_index]={};
				temp_obj_i=Node[P.N_index];
				temp_obj_i.pId= temp_obj_p.id;

				temp_obj_i.id = "i";
				temp_obj_i.id += info_id;
				temp_obj_i.id += temp_obj_p.id;
				//console.log(temp_obj_i.id);

				temp_obj_i.name='Original Service ID:' + $.decimalConvert(P.pn,system);
				temp_obj_i.t='Original Service ID';
				temp_obj_i.iconSkin="adddata";	
				
				P.N_index++;
				info_id++;
			}else
			{
				console.log("Original Service ID== NULL");
			}
			if(P.P_name)
			{
				Node[P.N_index]={};
				temp_obj_i=Node[P.N_index];
				temp_obj_i.pId= temp_obj_p.id; 
					
				temp_obj_i.id = "i";
				temp_obj_i.id += info_id;
				temp_obj_i.id += temp_obj_p.id;
				
				temp_obj_i.name='Original Name:' + P.P_name;
				
				if(P.P_FCA_MODE)
				{
					temp_obj_i.name += ' <b style="color:red">[$]</b>';
				}
				
				temp_obj_i.t = 'Original Name';
				temp_obj_i.iconSkin="adddata";	
				
				P.N_index++;
				info_id++;
			}
			else
			{
				console.log("Original name == NULL");
			}
			
			
			if(P.Src_name || P.CH_index)
			{
				Node[P.N_index]={};
				temp_obj_i=Node[P.N_index];
				temp_obj_i.pId= temp_obj_p.id; 
					
				temp_obj_i.id = "i";
				temp_obj_i.id += info_id;
				temp_obj_i.id += temp_obj_p.id;
				if(P.Src_name)
				{
					temp_obj_i.name='Source:'+P.Src_name;
				}
				else if(P.CH_index)
				{
					temp_obj_i.name='Source:'+$.decimalConvert(P.CH_index,system);
				}		
				temp_obj_i.t = "Source";
				temp_obj_i.iconSkin="adddata";	
				P.N_index++;
				info_id++;
			}


		}


		return P.N_index;
		
	};
		//生成输入树--------2015/09/07   -----------------
	$.pbi_GenInTreeProNodes=function(para,system)
		{
			var G=GlobalSpace,
				socNodes=[],
				p_para={},
				in_para=[],
				tree_items_index=0,
				temp_obj={},
				prog_obj={},
				temp_obj_p={},//program
				temp_obj_i={},//item
				tree_node=[],
				temp_es_pids=[],
				temp_ecm_pids=[],
				temp_num=0,
				temp_id="",
				temp_pid="",
				temp_name="",
				num_head="",
				mux_item=[],
				mux_pro=[],
				mux_pro_inch=0,
				mux_pro_pn=0,
				mux_pro_sou=[],
				mux_pro_t="",
				index_tree = 0,
				j = 0,
				num = 0,
				h = 0;
		
		/***************Init input tree**************
			in_para.INPUT_TREE.length :: 被选择的源.
			in_para.INPUT_TREE.src_num ::源号
		**********************************************/	
		G.INPUT_TREE_value = para.INPUT_TREE.value;
		in_para = para.INPUT_TREE.value;
		
		if(in_para)
		{
    		var k;
			//console.log(in_para.length);
             //console.log(G.socNodes[9].name);
           // console.log(G.socNodes[10].name);
          /*  for(var i=0;i<G.socNodes.length;i++){
                console.log(G.socNodes[i].name)
            }*/
            //debugger;
			for(var i=0,k=G.socNodes.length;i<in_para.length;i++)
			{	
					
				for(j=0;j<G.socNodes.length;j++)
				{					
					//G.socNodes[j].id 路由表生成的
                   // console.log(G.socNodes[j].name);
					if(parseInt(G.socNodes[j].pId) >= 1 && parseInt(G.socNodes[j].pId) <= 7)	
					{
						//if(parseInt(G.socNodes[j].id.slice(1)) == parseInt(in_para[i].src_num)  && (in_para[i].Channel_Bitrates > 0) && (G.socNodes[j].checked == true))
                        if(parseInt(G.socNodes[j].id.slice(1)) == parseInt(in_para[i].src_num)  && (in_para[i].Channel_Bitrates > 0))
						{

							G.src_old.push(in_para[i].src_num);

                            //console.log(G.socNodes[j].name);
                           // console.log(G.socNodes[10].name);
							G.socNodes[j].name += ' <b style="color:Green">['+in_para[i].Channel_Bitrates+']</b>';
                         //   console.log(in_para[i].In_Pro_infos.length);
							if(in_para[i].In_Pro_infos.length > 0)
							{
								for(num=0; num<in_para[i].In_Pro_infos.length; num++)
								{													
									p_para = {
										Have_flag	  :	1,
										CH_index      : parseInt(in_para[i].src_num),
										N_index       : k,
										P_index       : num,
										Src_name 	  : parseInt(in_para[i].src_num),
										S_TYPE        : in_para[i].In_Pro_infos[num].Program_Type,
										P_name        : in_para[i].In_Pro_infos[num].Ser_Name,
										P_name_new    : in_para[i].In_Pro_infos[num].Ser_Name,
										P_FCA_MODE    : in_para[i].In_Pro_infos[num].Fca_Mode,
										pn			  : in_para[i].In_Pro_infos[num].Pro_Num,
										pn_new			  : in_para[i].In_Pro_infos[num].Pro_Num,
										pmt_pid       : in_para[i].In_Pro_infos[num].Pmt_pid&0x1fff,
										pcr_pid       : in_para[i].In_Pro_infos[num].Pcr_pid&0x1fff,											
										temp_es_pids  : in_para[i].In_Pro_infos[num].Espids_Num,
										temp_ecm_pids : in_para[i].In_Pro_infos[num].Ecmpids_Num,
                                        caSysID        :in_para[i].In_Pro_infos[num].CA_System_ID,
                                        temp_obj       : G.socNodes[j]
			
									};
									 k = $.pbi_GenProTreeNode(G.socNodes,p_para,0,system,-1);  //Init input tree
																		
								}
                                /*--------添加 EMM-----*/
								for(var q in in_para[i].Emmpids_Num)
                                {
                                    G.socNodes[k]={};
                                    var tempEmmObj = G.socNodes[k];
                                    tempEmmObj.pId= G.socNodes[j].id;
                                    tempEmmObj.nocheck = true;
                                    tempEmmObj.id = "Emm";
                                    tempEmmObj.id += k;
                                    tempEmmObj.id += G.socNodes[j].id;
                                    tempEmmObj.iconSkin = "emm";
                                    tempEmmObj.t = "EMM";
                                    tempEmmObj.name =  $.decimalConvert(in_para[i].Emmpids_Num[q], system);
                                   // tempEmmObj.name = tempEmmObj.t + ':' + $.decimalConvert(in_para[i].Emmpids_Num[q], system);
                                    k++;
                                }
                                /*-------End EMM ------*/
							}						
						}
					}				
				}
			}				
		}
	};

	//生成输入源-------  2015/09/17   -----------------
	$.pbi_GenInSource=function(para,global,boardNum){

			var G=GlobalSpace,
				P = {
					SET_TRANS:{},
					tree_open:0,
					bitrate_ena:0
				},
			  	socNodes=[],

				dest_func_list = [], //transceiver->dest_func->func_list
				temp_num=0,		
				index_tree = 0,
				selected_index = 0,
				j = 0,	
				t=0,	
				num = 0,
				parent_check_flag = -1;
      //  console.log(G.socNodes);
        //console.log(socNodes);
			var tranifslot = [0,1,2,3,4,5,6,6,6,7,7,7,7,7,7,7];
			//console.log(boardNum);

         jQuery.extend(P, para);// extend 合并 p ,para. 有相同的 替换否则将保存.

         //P.tree_open --> 取决于para 里面 .
      //alert(window.top.document.getElementById("sel").value);
     if(window.top.document.getElementById("sel").value==1) {
         socNodes[0] = {id: '1', pId: 0, name: "Module 1", t: "Module 1", open: (P.tree_open & 1)};
         socNodes[1] = {id: '2', pId: 0, name: "Module 2", t: "Module 2", open: (P.tree_open & 1)};
         socNodes[2] = {id: '3', pId: 0, name: "Module 3", t: "Module 3", open: (P.tree_open & 1)};
         socNodes[3] = {id: '4', pId: 0, name: "Module 4", t: "Module 4", open: (P.tree_open & 1)};
         socNodes[4] = {id: '5', pId: 0, name: "Module 5", t: "Module 5", open: (P.tree_open & 1)};
         socNodes[5] = {id: '6', pId: 0, name: "Module 6", t: "Module 6", open: (P.tree_open & 1)};
         socNodes[6] = {id: '7', pId: 0, name: "M/B", t: "M/B", open: (P.tree_open & 1)};
     }else{
         socNodes[0] = {id: '1', pId: 0, name: "模组 1", t: "Module 1", open: (P.tree_open & 1)};
         socNodes[1] = {id: '2', pId: 0, name: "模组 2", t: "Module 2", open: (P.tree_open & 1)};
         socNodes[2] = {id: '3', pId: 0, name: "模组 3", t: "Module 3", open: (P.tree_open & 1)};
         socNodes[3] = {id: '4', pId: 0, name: "模组 4", t: "Module 4", open: (P.tree_open & 1)};
         socNodes[4] = {id: '5', pId: 0, name: "模组 5", t: "Module 5", open: (P.tree_open & 1)};
         socNodes[5] = {id: '6', pId: 0, name: "模组 6", t: "Module 6", open: (P.tree_open & 1)};
         socNodes[6] = {id: '7', pId: 0, name: "TS/IP", t: "M/B", open: (P.tree_open & 1)};
     }
         // console.log(socNodes);
         G.src_func_value = P.SET_TRANS.value.src_func;
         G.dest_func_value = P.SET_TRANS.value.dest_func;
         // console.log(socNodes);
         for(var i =0;i<G.dest_func_value.length;i++)
         {
         if(G.dest_func_value[i].module == boardNum) //boardNum 主板mux 值 && 子板复用值
         {
         if(G.dest_func_value[i].run_flag)
         {
             dest_func_list = G.dest_func_value[i].func_list;
         }
         else
         return socNodes;

         break;
         }
         }
         for(index_tree=0,j=7; index_tree<7; index_tree++)
         {
         if(index_tree == 6)
         {
         selected_index = 7;
         }
         else
         {
         selected_index = index_tree;
         }

         socNodes[index_tree].checked ="false";
         socNodes[index_tree].halfCheck ="false";
         socNodes[index_tree].iconSkin ="Model";

         if(typeof(G.src_func_value[selected_index].count) != "undefined" && G.src_func_value[selected_index].run_flag )
         {
         //init
         parent_check_flag = 0;
         if((index_tree>=0) && (index_tree<6) && G.ModelTitle[index_tree])
         {
         socNodes[index_tree].name += ' [';
         socNodes[index_tree].name += G.ModelTitle[index_tree].name;
         socNodes[index_tree].name += ']';

         }else
         {
         socNodes[index_tree].name += ' ';
         }
         //  console.log(socNodes[index_tree]);
         for(var src_num=0;src_num<G.src_func_value[selected_index].count;src_num++)
         {
         var tranif = (G.src_func_value[selected_index].func_list[src_num][3] >> 8) & 0xff; //主板：9 。复用板6-8
         if(tranifslot[tranif] != parseInt(boardNum) || G.src_func_value[selected_index].func_list[src_num][0] != parseInt(FUNC_TYPE.REMUX)) //if 是 主板，包括了复用，所以 的去掉
         {
         socNodes[j]={};
         temp_obj = socNodes[j];
         temp_obj.pId = parseInt(index_tree+1);

         temp_obj.id = "p";
         //temp_obj.id +="-";
         temp_obj.id += parseInt(G.src_func_value[selected_index].func_list[src_num][3]);

         temp_obj.name = G.src_func_value[selected_index].func_list[src_num][1];
         //temp_obj.name+="-";
         //temp_obj.name+= parseInt(G.src_func_value[selected_index].func_list[src_num][2]+1);
         //temp_obj.name+=" ";
      //   console.log(temp_obj.name);
         temp_obj.iconSkin = "pTs";
         temp_obj.t = temp_obj.name;

         temp_obj.checked = false;
         temp_obj.dest_func_channel = -1;

         for(t=0;t<dest_func_list.length;t++)
         {

         if(dest_func_list[t][0] == parseInt(FUNC_TYPE.TS_IN))
         {
         if(route_id == -1)
         {

         //	console.log(dest_func_list[t][6]);
         route_id = dest_func_list[t][6];
         }
         if((dest_func_list[t][3] == G.src_func_value[selected_index].module) && (dest_func_list[t][5] == G.src_func_value[selected_index].func_list[src_num][3]))
         {
             temp_obj.dest_func_channel = dest_func_list[t][2]; //level-1
             temp_obj.checked = true;
             parent_check_flag++ ;
             break;
         }
         }
         }
        // console.log(socNodes[j]);
         //console.log(socNodes[j].name);

         j++;

         }
         }

         if(parent_check_flag == 0) //no check
         {
             socNodes[index_tree].checked = false;
             socNodes[index_tree].halfCheck = false;
         }
         else if(parent_check_flag < G.src_func_value[selected_index].count) //halfCheck
         {
             socNodes[index_tree].checked = true;
             socNodes[index_tree].halfCheck = true;
         }else if(parent_check_flag == G.src_func_value[selected_index].count) //all check
         {
             socNodes[index_tree].checked = true;
             socNodes[index_tree].halfCheck = false;
         }

         }else
         {
             socNodes[index_tree].nocheck = true;
         }
         }

           // console.log(socNodes.length);
			return socNodes;
				
		};
	//生成输出树--------2015/09/24   -----------------
	$.pbi_GenSonBoardMuxTree=function(para,system)
	{
		var G=GlobalSpace,
			P = {
				INPUT_TREE:{},
				MUX_TREE:{},
				tree_open:1,
				bitrate_ena:0
			},
			muxNodes=[],
			p_para={},
			tree_items_index=0,
			temp_obj={},
			temp_obj_p={},//program
			temp_obj_i={},//item
			temp_value=[],
			temp_es=[],
			temp_num=0,
			temp_id="",
			temp_pid="",
			temp_name="",
			num_head="",
			mux_item=[],
			mux_pro=[],
			mux_pro_inch=0,
			mux_pro_pn=0,
			mux_pro_sou=[],
            temp_ecm_pids=[],
            mux_pro_t="",
			i = 0,
			j = 0,
			k = 0,
			h = 0;
		
		jQuery.extend(P, para);	
		G.MUX_TREE = P.MUX_TREE;
		tree_items_index = G.muxNodes.length;		

		G.muxNodes[0].checked = false;
		G.muxNodes[0].halfCheck = false;	
		
		for(i=0; i<G.MUX_TREE.value.length; i++)
		{
			//G.muxNodes[G.MUX_TREE.value[i].index].checked = true; //lxzheng 2016/02/23
			G.muxNodes[G.MUX_TREE.value[i].index].checked = false; //lxzheng 2016/02/24
			
			if(G.MUX_TREE.value[i].set_infos.chName) //for update Channel mux name 
			{
				G.muxNodes[G.MUX_TREE.value[i].index].name += "-";
				G.muxNodes[G.MUX_TREE.value[i].index].name += G.MUX_TREE.value[i].set_infos.chName;
				
				G.muxNodes[G.MUX_TREE.value[i].index].t += "-";
				G.muxNodes[G.MUX_TREE.value[i].index].t += G.MUX_TREE.value[i].set_infos.chName;
			}
			
			if(G.MUX_TREE.value[i].validBitrate.length > 0)
			{
				if(G.MUX_TREE.value[i].set_infos.muxSwitch == 1)
				{
					G.muxNodes[G.MUX_TREE.value[i].index].name += ' <b style="color:Green">['+G.MUX_TREE.value[i].validBitrate+'/'+G.MUX_TREE.value[i].set_infos.outBitrate+']</b>';
				}
				else
				{
					G.muxNodes[G.MUX_TREE.value[i].index].name += ' <b style="color:Gray">['+G.MUX_TREE.value[i].validBitrate+'/'+G.MUX_TREE.value[i].set_infos.outBitrate+']</b>';
				}
				
			}
			
			
		//	G.muxNodes[tree_items_index] = {}; //类似于 JAVA .相当于 传 指针.所以一改全改.
			mux_item = G.MUX_TREE.value[i];		
					
			if(mux_item){					
				for(j=0;j<mux_item.mux_infos.length; j++)
				{
					var src_flag=0,flag=0;
					mux_pro = mux_item.mux_infos[j]; //每一路 中 每一个 节目 信息
					mux_pro_inch = mux_pro.Src_index; //mux_pro_inch
					mux_pro_pn = mux_pro.prog_num;

					spro_ch = mux_pro_inch; //第几路输入的 数的节点
					spro_pn = mux_pro_pn;
					spro_name ='';
					spro_name_new ='';
					
				//	console.log(mux_pro_inch);
					for(var input=0;input<G.INPUT_TREE_value.length;input++)
					{
												
						if(mux_pro_inch == G.INPUT_TREE_value[input].src_num && G.INPUT_TREE_value[input].In_Pro_infos.length > 0) //不选源
						{			
							mux_pro_sou = G.INPUT_TREE_value[input].In_Pro_infos; //第几路输入的 数 
							//console.log(mux_pro_sou);
							src_flag = 1;
							break;
						}								
					}	
									
					if(src_flag == 1)
					{
						for(k=0; k<mux_pro_sou.length; k++)
						{
							if(mux_pro_pn==mux_pro_sou[k].Pro_Num)
							{	
								flag = 1;				
								break;
							}	
						}
					}
					
					if(flag == 1) //src_flag=1  证明 还有 节目，flag=1证明 没有 切换其他的拼点  也有 节目
					{					
						mux_pro.Pro_index = k; //src_num 下的 第几个 节目 
						var spro_arr = mux_pro_sou[k]; //每个节目的 信息		
						
						//a:b?c 条件表达式 为真,则 b ,否则 C
						spro_name+=spro_arr?spro_arr.Ser_Name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';	
						spro_name_new += mux_pro?mux_pro.prog_name_new:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';
					//	console.log(spro_arr.Program_Type);
						p_para = {
							Have_flag:1,
							CH_index:mux_pro_inch,
							N_index:tree_items_index,
							P_index:j,
							Src_name:mux_pro.Src_name,
							Program_Type:spro_arr.Program_Type,
							P_name:spro_name,	
							P_name_new:spro_name_new,					
							P_FCA_MODE:spro_arr&&spro_arr.Fca_Mode,
							pn:mux_pro_pn,
							pmt_pid:mux_pro.PMT_pid&0X1fff,
							pcr_pid:mux_pro.PCR_pid&0X1fff,
							temp_es_pids:mux_pro.Mux_pid_infos,
                            temp_ecm_pids :mux_pro.Ecmpids_Num,
                            temp_obj:G.muxNodes[G.MUX_TREE.value[i].index]
		
						};			
					}
					else
					{
						console.log("--NO Input Src-- !");
						//console.log(mux_pro.prog_name);
						//a:b?c 条件表达式 为真,则 b ,否则 C
						spro_name += mux_pro?mux_pro.prog_name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';	
						spro_name_new += mux_pro?mux_pro.prog_name_new:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';	
						
						p_para = {
							Have_flag:0,
							CH_index:mux_pro_inch,
							N_index:tree_items_index,
							P_index:j,
							Src_name:mux_pro.Src_name,
							Program_Type:mux_pro.Program_Type,
							P_name:spro_name,	
							P_name_new:spro_name_new,				
							P_FCA_MODE:0,
							pn:mux_pro_pn,
							pmt_pid:mux_pro.PMT_pid&0X1fff,
							pcr_pid:mux_pro.PCR_pid&0X1fff,
							temp_es_pids:mux_pro.Mux_pid_infos,
                            temp_ecm_pids :mux_pro.Ecmpids_Num,
                            temp_obj:G.muxNodes[G.MUX_TREE.value[i].index]
		
						};					
						
					}	
					
					tree_items_index = $.pbi_GenProTreeNode(G.muxNodes,p_para,1,system,6);		
					
				}
						
			}
			
		}		
		//return G.muxNodes; 
	};

	
	//生成输出树--------2015/09/24   -----------------
	$.pbi_GenMainBoardMuxTree=function(para,system)
	{
		var G=GlobalSpace,
			P = {
				INPUT_TREE:{},
				Edit_Program_Infos:{},
				MUX_SET_INFOS:{},
				Mux_Refresh_Infos:{},
				tree_open:1,
				bitrate_ena:0
			},
			muxNodes=[],
			p_para={},
			tree_items_index=0,
			temp_obj={},
			temp_obj_p={},//program
			temp_obj_i={},//item
			temp_value=[],
			temp_es=[],
			temp_num=0,
			temp_id="",
			temp_pid="",
			temp_name="",
			num_head="",
			mux_item=[],
			mux_pro=[],
			mux_pro_inch=0,
			mux_pro_pn=0,
			mux_pro_sou=[],
            temp_ecm_pids=[],
			mux_pro_t="",
			i = 0,
			j = 0,
			k = 0,
			h = 0,
			mux_index=-1,
			prog_index=-1;		
		jQuery.extend(P, para);	

		G.Edit_Program_Infos = P.Edit_Program_Infos;

		G.MUX_SET_INFOS = P.MUX_SET_INFOS;
		G.Mux_Refresh_Infos = P.Mux_Refresh_Infos;

		tree_items_index = G.muxNodes.length;		

		G.muxNodes[0].checked = false;
		G.muxNodes[0].halfCheck = false;	
		
		for(var mux_key in G.Edit_Program_Infos.value)  
		{
			//console.log(mux_key);
			mux_index = parseInt(mux_key.split("_")[1]);

			G.muxNodes[mux_index].checked = false; //lxzheng 2016/02/24
			
			if(G.MUX_SET_INFOS.value[mux_key].chName) //for update Channel mux name 
			{
				G.muxNodes[mux_index].name += "-";
				G.muxNodes[mux_index].name += G.MUX_SET_INFOS.value[mux_key].chName;
				
				G.muxNodes[mux_index].t += "-";
				G.muxNodes[mux_index].t += G.MUX_SET_INFOS.value[mux_key].chName;
			}

			if(parseInt(G.Mux_Refresh_Infos.value[mux_key].validBitrate) >= 0)
			{
				if(G.MUX_SET_INFOS.value[mux_key].muxSwitch == 1)
				{
					G.muxNodes[mux_index].name += ' <b style="color:Green">['+parseInt(G.Mux_Refresh_Infos.value[mux_key].validBitrate)+'/'+G.MUX_SET_INFOS.value[mux_key].outBitrate+']</b>';
				}
				else
				{
					G.muxNodes[mux_index].name += ' <b style="color:Gray">['+parseInt(G.Mux_Refresh_Infos.value[mux_key].validBitrate)+'/'+G.MUX_SET_INFOS.value[mux_key].outBitrate+']</b>';
				}
				
			}
					
			mux_item = G.Edit_Program_Infos.value[mux_key];
           // console.log(mux_key);
			if(mux_item){
				prog_index=-1;				
				for(var prog_key in mux_item)  
				{
				    if(prog_key =="Emmpids_Num"){
                        continue;
                    }
					prog_index++;
					//console.log(prog_key);
					var src_flag=0,flag=0;
					mux_pro = mux_item[prog_key]; //每一路 中 每一个 节目 信息
					mux_pro_inch = mux_pro.Trans_channel; //Trans_channel
					mux_pro_pn = mux_pro.Original_prog_infos.prog_num;
					mux_pro_pn_new = mux_pro.Mux_prog_infos.prog_num;
					mux_dest_func_channel = mux_pro.dest_func_channel;
					
					spro_ch = mux_pro_inch; //第几路输入的 数的节点
					spro_pn = mux_pro_pn;
					spro_name ='';
					spro_name_new ='';
					
					for(var input=0;input<G.INPUT_TREE_value.length;input++)
					{
												
						if(mux_pro_inch == G.INPUT_TREE_value[input].src_num && G.INPUT_TREE_value[input].In_Pro_infos.length > 0) //不选源
						{			
							mux_pro_sou = G.INPUT_TREE_value[input].In_Pro_infos; //第几路输入的 数 
							//console.log(mux_pro_sou);
							src_flag = 1;
							break;
						}								
					}
					if(src_flag == 1)
					{
						for(k=0; k<mux_pro_sou.length; k++)
						{
							if(mux_pro_pn==mux_pro_sou[k].Pro_Num)
							{
								flag = 1;
								break;
							}	
						}
					}

					//console.log(flag);
					/*	
					if(flag == 1) //src_flag=1  证明 还有 节目，flag=1证明 没有 切换其他的拼点  也有 节目
					{					
						mux_pro.Pro_index = k; //src_num 下的 第几个 节目 
						var spro_arr = mux_pro_sou[k]; //每个节目的 信息		
						
						//a:b?c 条件表达式 为真,则 b ,否则 C
						spro_name+=spro_arr?spro_arr.Ser_Name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';	
						spro_name_new += mux_pro?mux_pro.Mux_prog_infos.prog_name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]<b>';	
						
						p_para = {
							Have_flag:1,
							CH_index:mux_pro_inch,
							N_index:tree_items_index,
							P_index:prog_key,
							mux_dest_func_channel : mux_dest_func_channel,
							Src_name:mux_pro.Original_prog_infos.Src_name,
							S_TYPE:spro_arr.Program_Type,
							P_name:spro_name,	
							P_name_new:spro_name_new,					
							P_FCA_MODE:spro_arr&&spro_arr.Fca_Mode,
							pn:mux_pro_pn,
							pn_new:mux_pro_pn_new,
							pmt_pid:mux_pro.Mux_prog_infos.PMT_pid&0X1fff,
							pcr_pid:mux_pro.Mux_prog_infos.PCR_pid&0X1fff,
							temp_es_pids:mux_pro.Mux_pid_infos,
							temp_obj:G.muxNodes[G.MUX_TREE.value[i].index]
		
						};			
					}
					else
					{*/

						//a:b?c 条件表达式 为真,则 b ,否则 C
						//console.log(mux_pro.Original_prog_infos.prog_name);
						spro_name += mux_pro.Original_prog_infos.prog_name?mux_pro.Original_prog_infos.prog_name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]</b>';	
						spro_name_new += mux_pro.Mux_prog_infos.prog_name?mux_pro.Mux_prog_infos.prog_name:'<b class="r">[CH'+spro_ch+'-PN'+spro_pn+'][?]</b>';	
						//console.log(spro_name);
						p_para = {
							Have_flag:flag,
							prog_key:prog_key,
							CH_index:mux_pro_inch,
							N_index:tree_items_index,
							P_index:prog_index,							
							mux_dest_func_channel : mux_dest_func_channel,
							Src_name:mux_pro.Original_prog_infos.Src_name,
							S_TYPE:mux_pro.Mux_prog_infos.S_TYPE,
							P_name:spro_name,	
							P_name_new:spro_name_new,	
							P_FCA_MODE:mux_pro.Mux_prog_infos.Fca_Mode,			
							pn:mux_pro_pn,
							pn_new:mux_pro_pn_new,
							pmt_pid:mux_pro.Mux_prog_infos.PMT_pid&0X1fff,
							pcr_pid:mux_pro.Mux_prog_infos.PCR_pid&0X1fff,
                            pcr_pass:mux_pro.Mux_prog_infos.PCR_pass,
                            lcnVal:mux_pro.Mux_prog_infos.Lcn_val,
							temp_es_pids:mux_pro.Mux_pid_infos,
                            temp_ecm_pids :mux_pro.Ecmpids_Num,
                            caSysID :mux_pro.CA_System_ID,
                            temp_obj:G.muxNodes[mux_index]
						};
				//	}							

                    tree_items_index = $.pbi_GenProTreeNode(G.muxNodes,p_para,1,system,7);

					
				}

                /*--------添加 EMM-----*/
                if(mux_item["Emmpids_Num"]){
                    var EmmpidsNumObj = mux_item["Emmpids_Num"];
                    for(var caSysIDSrcKey in EmmpidsNumObj)
                    {
                        if(EmmpidsNumObj[caSysIDSrcKey]) {
                            G.muxNodes[tree_items_index] = {};
                            var tempEmmObj = G.muxNodes[tree_items_index];
                            tempEmmObj.pId = G.muxNodes[mux_index].id;
                            tempEmmObj.nocheck = true;
                            tempEmmObj.id = "Emm";
                            tempEmmObj.id += tree_items_index;
                            tempEmmObj.id += G.muxNodes[mux_index].id;
                            tempEmmObj.iconSkin = "emm";
                            tempEmmObj.t = "EMM";
                            tempEmmObj.name = $.decimalConvert(EmmpidsNumObj[caSysIDSrcKey].newEmm, system);
                            tempEmmObj.oriEmm = EmmpidsNumObj[caSysIDSrcKey].oriEmm;
                            tempEmmObj.pass = EmmpidsNumObj[caSysIDSrcKey].pass;
                            tempEmmObj.CASrcMuxKey = caSysIDSrcKey;
                            tree_items_index++;

                            //Original Emm
                            G.muxNodes[tree_items_index] = {};
                            temp_obj_son = G.muxNodes[tree_items_index];
                            temp_obj_son.pId = tempEmmObj.id;
                            temp_obj_son.id = "ei";
                            temp_obj_son.id += 1;
                            temp_obj_son.id += tempEmmObj.id;
                            temp_obj_son.nocheck = true;
                            temp_obj_son.iconSkin = "adddata";
                            temp_obj_son.t = "original Emm";
                            temp_obj_son.name = "Original Emm:";
                            temp_obj_son.name += tempEmmObj.oriEmm;
                            tree_items_index++;
                            //src_name
                            G.muxNodes[tree_items_index] = {};
                            var temp_obj_son = G.muxNodes[tree_items_index];
                            temp_obj_son.pId= tempEmmObj.id;
                            temp_obj_son.id = "ei";
                            temp_obj_son.id += 2;
                            temp_obj_son.id += tempEmmObj.id;
                            temp_obj_son.nocheck = true;
                            temp_obj_son.iconSkin = "adddata";
                            temp_obj_son.t = "src name";
                            temp_obj_son.name = "Source:";
                            temp_obj_son.name += EmmpidsNumObj[caSysIDSrcKey].src_name;
                            tree_items_index++;
                        }
                    }
                }
			}
			
		}		
		//return G.muxNodes; 
	};

//===
 $.MS_GenInSource=function (para,global,boardNum){
		var P={
			MS_Para: [],
			tree_open:0,
			bitrate_ena:0
		};
	var G=GlobalSpace,
		// P =[],
		socNodes=[],
		dest_func_list = [], //transceiver->dest_func->func_list
		temp_num=0,		
		index_tree = 0,
		selected_index = 0,
		j = 0,	
		t=0,	
		num = 0,
		parent_check_flag = -1;
	var tranifslot = [0,1,2,3,4,5,6,6,6,7,7,7,7,7,7,7];
	//console.log(boardNum);
   //  console.log("11111111111");
	jQuery.extend(P, para);// extend 合并 p ,para. 有相同的 替换否则将保存.
	// P.tree_open --> 取决于para 里面 .
	socNodes[0] ={id:'1',pId:0,name:"Module 1",t:"Module 1",open:(P.tree_open&1)};
	socNodes[1] ={id:'2',pId:0,name:"Module 2",t:"Module 2",open:(P.tree_open&1)};
	socNodes[2] ={id:'3',pId:0,name:"Module 3",t:"Module 3",open:(P.tree_open&1)};
	socNodes[3] ={id:'4',pId:0,name:"Module 4",t:"Module 4",open:(P.tree_open&1)};
	socNodes[4] ={id:'5',pId:0,name:"Module 5",t:"Module 5",open:(P.tree_open&1)};
	socNodes[5] ={id:'6',pId:0,name:"Module 6",t:"Module 6",open:(P.tree_open&1)};
	socNodes[6] ={id:'7',pId:0,name:"M/B",t:"M/B",open:(P.tree_open&1)};

	for(index_tree=0,j=7; index_tree<P.MS_Para.length; index_tree++)
	{	
		if(index_tree == 6)
			selected_index = 7;
		else if(index_tree == 7)
			break;
		else 
			selected_index = index_tree;
		
		socNodes[index_tree].checked ="false";					
		socNodes[index_tree].halfCheck ="false";
		socNodes[index_tree].iconSkin ="Model";
		parent_check_flag = 0;	
	
		if(typeof(P.MS_Para[selected_index].channels) != "undefined" &&typeof(P.MS_Para[selected_index].count) != "undefined" && P.MS_Para[selected_index].run_flag )
		{	
			if((index_tree>=0) && (index_tree<6) && G.ModelTitle[index_tree])
			{
				socNodes[index_tree].name += ' [';
				socNodes[index_tree].name += G.ModelTitle[index_tree].name;
				socNodes[index_tree].name += ']';
			}else
			{
				socNodes[index_tree].name += ' ';
			}
			for(var src_num=0;src_num<P.MS_Para[selected_index].count;src_num++)
			{	
					socNodes[j]={};
					temp_obj = socNodes[j];		
					temp_obj.pId = parseInt(index_tree+1);
					temp_obj.id = "p";
					temp_obj.iconSkin = "pTs";		
					temp_obj.t = temp_obj.name;
					temp_obj.checked = false;	
					temp_obj.id += src_num;			
					temp_obj.name = P.MS_Para[selected_index].channels[src_num].name;
					temp_obj.trans_chan = P.MS_Para[selected_index].channels[src_num].trans_chan;
					temp_obj.t = temp_obj.name;
					if(P.MS_Para[selected_index].channels[src_num].switchbits >0){
						temp_obj.checked = true;
						parent_check_flag++ ;			
					}					
					j++;	
			}
			if(parent_check_flag == 0) //no check
			{
				socNodes[index_tree].checked = false;		
				socNodes[index_tree].halfCheck = false;		
			}			
			else if(parent_check_flag <P.MS_Para[selected_index].count) //halfCheck
			{
				socNodes[index_tree].checked = true;
				socNodes[index_tree].halfCheck = true;
			}else if(parent_check_flag == P.MS_Para[selected_index].count) //all check
			{ 
				socNodes[index_tree].checked = true;
				socNodes[index_tree].halfCheck = false;		
			}		
		}else
		  {
			socNodes[index_tree].nocheck = true;	
		  }


    }
	return socNodes;
};

$.MS_onTimer_Refresh_pro_list_success =function(para) 
{
	var P={
			MS_Para: [],
			tree_open:0,
			bitrate_ena:0
		};
	var 
		G=GlobalSpace,
		in_para={},
		addNodes=[],
		p_para={},
		mux_para={},
		tree_items_index=0,
		temp_obj={},
		prog_obj={},
		temp_obj_p={},//program
		temp_obj_i={},//item
		tree_node=[],
		temp_es_pids=[],
		temp_ecm_pids=[],
		temp_emm_pids=[],
		temp_num=0,
		temp_id="",
		temp_pid="",
		temp_name="",
		num_head="",
		mux_item=[],
		mux_pro=[],
		mux_pro_inch=0,
		mux_pro_pn=0,
		mux_pro_sou=[],
		mux_pro_t="",
		index_tree = 0;
		
		source_setting={
		treeId:"s",
		view:{
			nameIsHTML: true,
			showIcon: showIconForTree,
			showTitle: false
		},
		data: {
			key: {
				title:"t"
			},
			simpleData: {enable: true}
		},
		callback: {
			onDrag:false,
			beforeCheck: source_beforeCheck,
			onCheck:source_onCheck
		},
		check:{
			enable:true,
			nocheckInherit: true,
			chkboxType: { "Y": "ps", "N": "ps" }
		}
	};
	P=para;
	$.fn.zTree.init($("#t_source"), source_setting, G.socNodes);
	source_treeObj = $.fn.zTree.getZTreeObj("t_source");
	src_Menu = $("#src_Menu");
	 var checknodes = source_treeObj.getCheckedNodes(true);
	 for(var temp=0;temp<checknodes.length;temp++) 
	 {
		 source_treeObj.expandNode(checknodes[temp], true, false, true);
	 }
};
//===

})( jQuery); 

































